unit Thunk;

{
  Inno Setup
  Copyright (C) 1998-99 Jordan Russell
  For conditions of distribution and use, see LICENSE.TXT.

  Imports for generic thunks on Win16
}

interface

{$IFNDEF WIN32}

uses
  WinProcs, WinTypes, SysUtils;

var
  ThunkingFunctionsPresent: Boolean;
  LoadLibraryEx32W: function(lpszLibFile: PChar; hFile: Longint; dwFlags: Longint): Longint;
  GetProcAddress32W: function(hInst: Longint; lpszProc: PChar): Longint;
  CallProc32W: function(lpProcAddress32: Longint; fAddressConvert: Longint; nParams: Longint): Longint;
  FreeLibrary32W: function(hInst: Longint): BOOL;

{$ENDIF}

implementation

{$IFNDEF WIN32}

var
  KernelHandle: THandle;

procedure Deinit; far;
begin
  FreeLibrary (KernelHandle);
end;

begin
  KernelHandle := LoadLibrary('KERNEL');
  @LoadLibraryEx32W := GetProcAddress(KernelHandle, 'LoadLibraryEx32W');
  @GetProcAddress32W := GetProcAddress(KernelHandle, 'GetProcAddress32W');
  @CallProc32W := GetProcAddress(KernelHandle, 'CallProc32W');
  @FreeLibrary32W := GetProcAddress(KernelHandle, 'FreeLibrary32W');
  ThunkingFunctionsPresent := (@LoadLibraryEx32W <> nil) and
    (@GetProcAddress32W <> nil) and (@CallProc32W <> nil) and
    (@FreeLibrary32W <> nil);
  AddExitProc (Deinit);

{$ENDIF}

end.

